<?php
//
// HowMany PHP V2.0 (Compteur du nombre de connexions simultanes)
// par ED prod
// javascript-lab@nexen.net
// http://javascript-lab.nexen.net

/*****************************************************************/
/*****************************************************************/
/**			    Modif par SZ    V2.5		**/
/**			    ------------			**/
/**		    webmasteur@scripts-zone.com 		**/
/**		   ---------------------------			**/
/**		    http://www.scripts-zone.com 		**/
/**		   ---------------------------			**/
/** Ce qu'il y a de nouveaux :					**/
/** Unique ID change maintenant c'est Connect N+ l'ip,	**/
/** Un sysytme trs pratique de statistiques,			**/
/** qui affiche le nombre de visiteurs, de pages vues et,	**/
/** le nombre de pages vues par visiteurs			**/
/** L'affichage de s automatique a la place de (s)		**/
/** Et une lgende explicative					**/
/*****************************************************************/
/*****************************************************************/

$ip = getenv("REMOTE_ADDR"); // on rcupre l'IP du client
$agent = getenv("HTTP_USER_AGENT"); // on recupere le navigateur du client
$uid="Connect N$ip"; // creation de l'unique ID qui est Connect N+le numro
$ctime=time();
//
// Repertorie tout les fichiers du rpertoire 'connexions'
// verifie si timeout ,incremente compteur le cas chant
//
$nb_connectes=0; // reinitialisation compteur
$fp = opendir("connexions"); // on ouvre le repertoire 'connexions'
while ($file = readdir($fp)) // tans qu'il y a des fichiers dedans
{
 if ($file!="." && $file!="..") // evite repertoire courant et parent
 {
  $named="connexions/".$file;
  $lefichier = fopen($named ,"r"); // on ouvre le fichier
  if($lefichier) {
   flock($lefichier,2); //lock
   $timec=fgets($lefichier, 2048); // on lit les infos
   $tip=fgets($lefichier, 2048); 
   $tagent=fgets($lefichier, 2048);
   $tuid=fgets($lefichier, 2048);
   if ($ip==$file) {$uid=$tuid;} // c'est une connexion deja existante,on garde le meme UID 
   $temps=($ctime-$timec); // soustrait heure de connexion a heure courante,on obtient le dcalage en secondes
   flock($lefichier,3); //unlock
   fclose($lefichier); // on ferme
   if ($ip<>$file)
   {
    if ($temps<240) // si temps de connexion inferieur a 240 sec, connexion valide
    {
     $nb_connectes=$nb_connectes+1; // on incremente le compteur
    }
    else
    {
     // timeout, on suprime le fichier
	 if ($temps>360) {
	  $kill=unlink($named);
	 }
    }
   }
  }
 }
}
closedir($fp); // on referme le rpertoire 'connexions'

//
// cre (ou ouvre si deja existant) le fichier correspondant a l'IP dans le rpertoire 'connexions'
// et stocke les infos
//
$ctime = time(); // heure de connexion en secondes
$lefichier = fopen("connexions/".$ip ,"w+"); // ouvre le fichier
if($lefichier) {
 flock($lefichier,2); //lock
 $ecrit = fwrite ($lefichier, $ctime.chr(10) ); // ecriture de l'heure de cnx dans le fichier
 $ecrit = fwrite ($lefichier, $ip.chr(10) ); // ecriture de l'ip dans le fichier
 $ecrit = fwrite ($lefichier, $agent.chr(10) ); // ecriture de l'agent dans le fichier
 $ecrit = fwrite ($lefichier, $uid.chr(10) ); // ecriture de l'UID dans le fichier
 flock($lefichier,3); //unlock
 fclose($lefichier); // on ferme le fichier
 $nb_connectes=$nb_connectes+1; // on incremente le compteur
}

//
// on modifie la chaine nb_connectes de facon a avoir 5 chiffre (00001)
//
if (strlen($nb_connectes)<5)
{
	$temp=str_repeat("0",5-strlen($nb_connectes)).$nb_connectes;
	$nb_connectes=$temp;
}

//
// verifie si message en attente
//
$nb_msg=0; // reinitialisation compteur
$fp = opendir("messages"); // on ouvre le repertoire 'connexions'
while ($file = readdir($fp)) // tans qu'il y a des fichiers dedans
{
 if ($file!="." && $file!="..") // evite repertoire courant et parent
 {
  $pos = strpos ($file, $ip); // message pour le client?
  if ($pos == TRUE) {
   $nb_msg=$nb_msg+1;
  }
 }
}
closedir($fp); // on referme le rpertoire 'messages'
if (strlen($nb_msg)<2)
{
	$temp=str_repeat("0",2-strlen($nb_msg)).$nb_msg;
	$nb_msg=$temp;
}

if($nb_connectes<2)
{			      //Moins de 2 connects
 $cos=Connect; 	      //on vire le "S"  la fin :)
}
else
{
 $cos=Connects;	     //si plus il reste ;)
}

if($nb_msg<2)
{			      //Moins de 2 Mesages
 $nb_msgs=Msg;		     //on vire le "S"  la fin :)
}
else
{
 $nb_msgs=MsgS; 	    //si plus il reste ;) avec un S majuscule pour le faire remarqu (il faudrait les lires !!)
}

//
// affiche le nombre de connects et le nombre de message grace a une image jpeg
//
$image = imagecreate(169,16);
$colorBlack = imagecolorallocate($image, 0, 0, 0);
$colorWhite = imagecolorallocate($image, 255,255,255);
$colorBlue = imagecolorallocate($image, 99,115,189);
imagefill($image, 0, 0, $colorBlue);
ImageFilledRectangle($image,75,2,111,13,$colorWhite);
imageFillToBorder($image,0,0,$colorBlack,$colorBlue);

imageString($image, 3, 1, 1, "$cos : ", $colorWhite);
imageString($image, 3, 76, 1, $nb_connectes, $colorBlack);
imageString($image, 3, 114, 1, "$nb_msgs : $nb_msg", $colorWhite);

//send image
header("Content-type: image/jpeg");
imagejpeg($image);

php?>
